
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class RemindersDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const reminders = await db.reminders.create(
            {
                id: data.id || undefined,
        
        message: data.message
        ||
        null
            ,
            
        remind_at: data.remind_at
        ||
        null
            ,
            
        channel: data.channel
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        sent_at: data.sent_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await reminders.setTenant( data.tenant || null, {
            transaction,
        });
        
        await reminders.setUser( data.user || null, {
            transaction,
        });
        
        await reminders.setTask( data.task || null, {
            transaction,
        });
        
        await reminders.setDeal( data.deal || null, {
            transaction,
        });
        
        await reminders.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return reminders;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const remindersData = data.map((item, index) => ({
                id: item.id || undefined,
                
                message: item.message
            ||
            null
            ,
            
                remind_at: item.remind_at
            ||
            null
            ,
            
                channel: item.channel
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                sent_at: item.sent_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const reminders = await db.reminders.bulkCreate(remindersData, { transaction });

        // For each item created, replace relation files
        

        return reminders;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const reminders = await db.reminders.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.message !== undefined) updatePayload.message = data.message;
        
        
        if (data.remind_at !== undefined) updatePayload.remind_at = data.remind_at;
        
        
        if (data.channel !== undefined) updatePayload.channel = data.channel;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.sent_at !== undefined) updatePayload.sent_at = data.sent_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await reminders.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await reminders.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await reminders.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.task !== undefined) {
            await reminders.setTask(
              
              data.task,
              
              { transaction }
            );
        }
        
        if (data.deal !== undefined) {
            await reminders.setDeal(
              
              data.deal,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await reminders.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return reminders;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const reminders = await db.reminders.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of reminders) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of reminders) {
                await record.destroy({transaction});
            }
        });


        return reminders;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const reminders = await db.reminders.findByPk(id, options);

        await reminders.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await reminders.destroy({
            transaction
        });

        return reminders;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const reminders = await db.reminders.findOne(
            { where },
            { transaction },
        );

        if (!reminders) {
            return reminders;
        }

        const output = reminders.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await reminders.getTenant({
            transaction
        });
        
        
        output.user = await reminders.getUser({
            transaction
        });
        
        
        output.task = await reminders.getTask({
            transaction
        });
        
        
        output.deal = await reminders.getDeal({
            transaction
        });
        
        
        output.organizations = await reminders.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.tasks,
        as: 'task',
        
        where: filter.task ? {
          [Op.or]: [
            { id: { [Op.in]: filter.task.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.task.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.deals,
        as: 'deal',
        
        where: filter.deal ? {
          [Op.or]: [
            { id: { [Op.in]: filter.deal.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.deal.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.message) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'reminders',
                        'message',
                        filter.message,
                    ),
                };
            }
            

            
            

            
            if (filter.remind_atRange) {
                const [start, end] = filter.remind_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    remind_at: {
                    ...where.remind_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    remind_at: {
                    ...where.remind_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.sent_atRange) {
                const [start, end] = filter.sent_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.channel) {
                where = {
                    ...where,
                channel: filter.channel,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.reminders.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'reminders',
                        'message',
                        query,
                    ),
                ],
            };
        }

        const records = await db.reminders.findAll({
            attributes: [ 'id', 'message' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['message', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.message,
        }));
    }

    
};

